<?php
/*
 * $Horde: horde/lib/MIME/Viewer/rar.php,v 1.4.2.4 2003/01/03 12:48:26 jan Exp $
 *
 * Copyright 1999-2003 Anil Madhavapeddy <anil@recoil.org>
 *
 * See the enclosed file COPYING for license information (LGPL). If you
 * did not receive this file, see http://www.fsf.org/copyleft/lgpl.html.
 */

/**
 * The MIME_Viewer_rar class renders out .rar archives
 * in HTML format by executing rar in query mode.
 *
 * @author  Anil Madhavapeddy <anil@recoil.org>
 * @version $Revision: 1.2 $
 * @since   Horde 1.3
 * @package horde.mime.viewer
 */
class MIME_Viewer_rar extends MIME_Viewer {

    /**
     * Render out the currently set contents using rar.  The
     * $mime_part class variable has the information to render out,
     * encapsulated in a MIME_Part object.
     *
     * @return string HTML pretty-print of the content
     */
    function render($params = null)
    {
        global $mime_drivers;

        /* Check to make sure the program actually exists. */
        if (file_exists($mime_drivers['rar']['location']) === false) {
            return sprintf("The program used to view this message type (%s) was not found on the system.", $mime_drivers['rar']['location']);
        }

        $tmp_rar = tempnam('','mgw_files');

        $fh = fopen($tmp_rar, 'w');
        fwrite($fh, $this->mime_part->getContents());
        fclose($fh);

        $pipe = popen($mime_drivers['rar']['location'] . " l $tmp_rar 2>&1", 'r');
        $data = '<pre class="file_content">';

        $re = '';
        while (($rc = fgets($pipe, 8192))) {
            $re .= $rc;
        }
        $data .= htmlspecialchars($re, ENT_QUOTES, $_SESSION['MGW']->charset);
        $data .= '</pre>';


        pclose($pipe);
	unlink($tmp_rar);

        return $data;
    }

    function getType()
    {
        return 'text/html';
    }

}
